//---------------------------------------------------------------------------
//
// Name:        dialog_train.h
// Author:      Chad Rempp
// Created:     6/9/2005 2:33:34 PM
//
//---------------------------------------------------------------------------
#ifndef __DIALOG_TRAIN_HPP_
#define __DIALOG_TRAIN_HPP_


// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif


//Do not add custom headers.
//wx-dvcpp designer will remove them
////Header Include Start
#include <wx/button.h>
#include <wx/grid.h>
////Header Include End

#include <wx/dialog.h>

//Compatibility for 2.4.x code
#ifndef wxCLOSE_BOX
#define wxCLOSE_BOX 0x1000
#endif
#ifndef wxFIXED_MINSIZE
#define wxFIXED_MINSIZE 0
#endif

////Dialog Style Start
	#define THIS_DIALOG_STYLE  wxVSCROLL  | wxCAPTION | wxSYSTEM_MENU | wxMINIMIZE_BOX |  wxCLOSE_BOX
////Dialog Style End

class Dialog_Train : public wxDialog
{
public:
    Dialog_Train( wxWindow *parent, wxWindowID id = 1, const wxString &title = _T("Training Data"),
        const wxPoint& pos = wxDefaultPosition,
        const wxSize& size = wxDefaultSize,
        long style = THIS_DIALOG_STYLE);
    virtual ~Dialog_Train();

public:

  //Do not add custom Control Declarations here.
  //wx-devcpp will remove them. Try adding the custom code 
  //after the block.
  ////GUI Control Declaration Start
	wxButton *butt_save;
	wxButton *butt_rand;
	wxGrid *grid_train;
  ////GUI Control Declaration End

private:
    DECLARE_EVENT_TABLE()

public:
    //Note: if you receive any error with these enums, then you need to
    //change your old form code that are based on the #define control ids.
    //#defines may replace a numeric value for the enums names.
    //Try copy pasting the below block in your old Form header Files.
	enum {
////GUI Enum Control ID Start
ID_BUTT_SAVE = 1004 ,
ID_BUTT_RAND = 1003 ,
ID_GRID_TRAIN = 1002 ,
////GUI Enum Control ID End
   ID_DUMMY_VALUE_ //Dont Delete this DummyValue
   }; //End of Enum

public:
    void Dialog_TrainClose(wxCloseEvent& event);
    void CreateGUIControls(void);

};


#endif
 
 
 
 
