//---------------------------------------------------------------------------
//
// Name:        nerek_frm.cpp
// Author:      Chad Rempp
// Created:     6/7/2005 1:06:41 PM
//
//---------------------------------------------------------------------------

#include "nerek_frm.h"
#include "dialog_train.h"
//Do not add custom headers.
//wx-dvcpp designer will remove them
////Header Include Start
#include "NerekFrm_XPM.xpm"
#include "toolbutt_opentrain_XPM.xpm"
#include "toolbutt_opendata_XPM.xpm"
#include "toolbutt_opennet_XPM.xpm"
#include "toolbutt_newtrain_XPM.xpm"
#include "toolbutt_newdata_XPM.xpm"
#include "toolbutt_newnet_XPM.xpm"
////Header Include End


//----------------------------------------------------------------------------
// NerekFrm
//----------------------------------------------------------------------------
   //Add Custom Events only in the appropriate Block.
   // Code added in  other places will be removed by wx-dvcpp 
  ////Event Table Start
BEGIN_EVENT_TABLE(NerekFrm,wxFrame)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(NerekFrm::NerekFrmClose)
	EVT_MENU(ID_MNU_E_XIT_1005 , NerekFrm::Mnuexit1005Click)
	EVT_MENU(ID_MNU__ABOUT_1006 , NerekFrm::Mnuabout1006Click)
	EVT_BUTTON(ID_BUTT_CREATE,NerekFrm::butt_createClick)
	EVT_BUTTON(ID_BUTT_VIZ3D,NerekFrm::butt_viz3dClick)
	EVT_BUTTON(ID_BUTT_VIZ2D,NerekFrm::butt_viz2dClick)
	EVT_BUTTON(ID_BUTT_TEST,NerekFrm::butt_testClick)
	EVT_BUTTON(ID_BUTT_TRAIN,NerekFrm::butt_trainClick)
	EVT_MENU(ID_TOOLBUTT_NEWTRAIN,NerekFrm::toolbutt_newtrainClick)
END_EVENT_TABLE()
  ////Event Table End



NerekFrm::NerekFrm( wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style )
    : wxFrame( parent, id, title, position, size, style)
{
    CreateGUIControls();
}

NerekFrm::~NerekFrm() {} 

void NerekFrm::CreateGUIControls(void)
{
    //Do not add custom Code here
    //wx-devcpp designer will remove them.
    //Add the custom code before or after the Blocks
    ////GUI Items Creation Start

	statbar_controls =  new wxStatusBar(this, ID_STATBAR_CONTROLS );
	statbar_controls->SetFieldsCount(1);
	statbar_controls->SetStatusText(_("Nerek Neural Simulator"),0);
	int statbar_controls_Widths[1];
	statbar_controls_Widths[0] = -1;
	statbar_controls->SetStatusWidths(1,statbar_controls_Widths);

	toolbar_controls =  new wxToolBar(this, ID_TOOLBAR_CONTROLS , wxPoint(0,0),wxSize(387,29) );

	wxBitmap toolbutt_newnet_BITMAP (toolbutt_newnet_XPM);
	wxBitmap toolbutt_newnet_DISABLE_BITMAP (wxNullBitmap);
	toolbar_controls->AddTool(ID_TOOLBUTT_NEWNET,_(""),toolbutt_newnet_BITMAP , toolbutt_newnet_DISABLE_BITMAP, wxITEM_NORMAL,_(""),_(""));

	wxBitmap toolbutt_newdata_BITMAP (toolbutt_newdata_XPM);
	wxBitmap toolbutt_newdata_DISABLE_BITMAP (wxNullBitmap);
	toolbar_controls->AddTool(ID_TOOLBUTT_NEWDATA,_(""),toolbutt_newdata_BITMAP , toolbutt_newdata_DISABLE_BITMAP, wxITEM_NORMAL,_(""),_(""));

	wxBitmap toolbutt_newtrain_BITMAP (toolbutt_newtrain_XPM);
	wxBitmap toolbutt_newtrain_DISABLE_BITMAP (wxNullBitmap);
	toolbar_controls->AddTool(ID_TOOLBUTT_NEWTRAIN,_(""),toolbutt_newtrain_BITMAP , toolbutt_newtrain_DISABLE_BITMAP, wxITEM_NORMAL,_(""),_(""));

	wxBitmap toolbutt_opennet_BITMAP (toolbutt_opennet_XPM);
	wxBitmap toolbutt_opennet_DISABLE_BITMAP (wxNullBitmap);
	toolbar_controls->AddTool(ID_TOOLBUTT_OPENNET,_(""),toolbutt_opennet_BITMAP , toolbutt_opennet_DISABLE_BITMAP, wxITEM_NORMAL,_(""),_(""));

	wxBitmap toolbutt_opendata_BITMAP (toolbutt_opendata_XPM);
	wxBitmap toolbutt_opendata_DISABLE_BITMAP (wxNullBitmap);
	toolbar_controls->AddTool(ID_TOOLBUTT_OPENDATA,_(""),toolbutt_opendata_BITMAP , toolbutt_opendata_DISABLE_BITMAP, wxITEM_NORMAL,_(""),_(""));

	wxBitmap toolbutt_opentrain_BITMAP (toolbutt_opentrain_XPM);
	wxBitmap toolbutt_opentrain_DISABLE_BITMAP (wxNullBitmap);
	toolbar_controls->AddTool(ID_TOOLBUTT_OPENTRAIN,_(""),toolbutt_opentrain_BITMAP , toolbutt_opentrain_DISABLE_BITMAP, wxITEM_NORMAL,_(""),_(""));

	panel_controls =  new wxPanel(this, ID_PANEL_CONTROLS, wxPoint(0,29),wxSize(387,518) );

	stattext_ilayers =  new wxStaticText(panel_controls, ID_STATTEXT_ILAYERS ,_("Input Layers") ,wxPoint(6,10),wxSize(64,18)  );
	stattext_ilayers->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("Arial")));

	stattext_olayers =  new wxStaticText(panel_controls, ID_STATTEXT_OLAYERS ,_("Output Layers") ,wxPoint(4,31),wxSize(73,18)  );
	stattext_olayers->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("Arial")));

	stattext_iterations =  new wxStaticText(panel_controls, ID_STATTEXT_ITERATIONS ,_("Iterations") ,wxPoint(28,111),wxSize(48,18)  );
	stattext_iterations->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("Arial")));

	stattext_rate =  new wxStaticText(panel_controls, ID_STATTEXT_RATE ,_("Learning Rate") ,wxPoint(4,59),wxSize(71,18)  );
	stattext_rate->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("Arial")));

	stattext_bias =  new wxStaticText(panel_controls, ID_STATTEXT_BIAS ,_("Bias") ,wxPoint(52,83),wxSize(25,18)  );
	stattext_bias->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("Arial")));

	edit_ilayers =  new wxTextCtrl(panel_controls, ID_EDIT_ILAYERS, _("3") , wxPoint(76,3),wxSize(121,22) );
	edit_ilayers->SetMaxLength(0);
	edit_ilayers->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("Arial")));

	edit_olayers =  new wxTextCtrl(panel_controls, ID_EDIT_OLAYERS, _("3") , wxPoint(76,27),wxSize(121,21) );
	edit_olayers->SetMaxLength(0);

	edit_rate =  new wxTextCtrl(panel_controls, ID_EDIT_RATE, _(".1") , wxPoint(76,55),wxSize(121,21) );
	edit_rate->SetMaxLength(0);

	edit_bias =  new wxTextCtrl(panel_controls, ID_EDIT_BIAS, _("-1") , wxPoint(76,79),wxSize(121,21) );
	edit_bias->SetMaxLength(0);

	edit_iterations =  new wxTextCtrl(panel_controls, ID_EDIT_ITERATIONS, _("1000") , wxPoint(76,107),wxSize(121,21) );
	edit_iterations->SetMaxLength(0);

	butt_train =  new wxButton(panel_controls, ID_BUTT_TRAIN, _("Train") , wxPoint(220,3),wxSize(43,25) );

	butt_test =  new wxButton(panel_controls, ID_BUTT_TEST, _("Test") , wxPoint(220,27),wxSize(43,25) );

	butt_viz2d =  new wxButton(panel_controls, ID_BUTT_VIZ2D, _("Viz 2D") , wxPoint(268,3),wxSize(43,25) );

	butt_viz3d =  new wxButton(panel_controls, ID_BUTT_VIZ3D, _("Viz 3D") , wxPoint(268,27),wxSize(43,25) );

	edit_log =  new wxTextCtrl(panel_controls, ID_EDIT_LOG, _("") , wxPoint(8,159),wxSize(369,333)  , wxVSCROLL |  wxHSCROLL  | wxTE_READONLY);
	edit_log->SetMaxLength(0);
	edit_log->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("Courier")));

	stattext_log =  new wxStaticText(panel_controls, ID_STATTEXT_LOG ,_("Log") ,wxPoint(4,139),wxSize(22,17)  );

	butt_create =  new wxButton(panel_controls, ID_BUTT_CREATE, _("Create Net") , wxPoint(220,59),wxSize(91,25) );

	menu_controls =  new wxMenuBar( );
	wxMenu *ID_MNU_FILE_1003_Mnu_Obj = new wxMenu(0);
	menu_controls->Append(ID_MNU_FILE_1003_Mnu_Obj,_("&File"));
	
	ID_MNU_FILE_1003_Mnu_Obj->Append(ID_MNU_E_XIT_1005,_("E&xit"),_("Quit NeReK"), wxITEM_NORMAL);
	
	wxMenu *ID_MNU__HELP_1004_Mnu_Obj = new wxMenu(0);
	menu_controls->Append(ID_MNU__HELP_1004_Mnu_Obj,_("&Help"));
	
	ID_MNU__HELP_1004_Mnu_Obj->Append(ID_MNU__ABOUT_1006,_("&About"),_("Show about dialog"), wxITEM_NORMAL);
	
	
	this->SetMenuBar(menu_controls);

	toolbar_controls->SetToolBitmapSize(wxSize(16,16));
	toolbar_controls->Realize();
	this->SetToolBar(toolbar_controls);
	this->SetStatusBar(statbar_controls);
	this->SetSize(8,8,395,593);
	this->SetTitle(_("NeReK Simulator"));
	this->Center();
	wxIcon NerekFrm_ICON (NerekFrm_XPM);
	this->SetIcon(NerekFrm_XPM);
	
    ////GUI Items Creation End
}

void NerekFrm::NerekFrmClose(wxCloseEvent& event)
{
    // --> Don't use Close with a Frame,
    // use Destroy instead.
    Destroy();
}
 

/*
 * Mnuexit1005Click
 */
void NerekFrm::Mnuexit1005Click(wxCommandEvent& event)
{
	// insert your code here
	Close(true);
}

/*
 * Mnuabout1006Click
 */
void NerekFrm::Mnuabout1006Click(wxCommandEvent& event)
{
	// insert your code here
	wxString msg;
    
    msg.Printf( _T("This is the About dialog of the minimal sample.\n")
                _T("Welcome to %s"),
                wxVERSION_STRING);
    
    wxMessageBox(msg, _T("About Minimal"),
                      wxOK | wxICON_INFORMATION, this);
}

/*
 * butt_trainClick
 */
void NerekFrm::butt_trainClick(wxCommandEvent& event)
{
	*edit_log << _T("Pressed Train\n");
}

/*
 * butt_testClick
 */
void NerekFrm::butt_testClick(wxCommandEvent& event)
{
     *edit_log << _T("Pressed Test\n");
}

/*
 * butt_viz2dClick
 */
void NerekFrm::butt_viz2dClick(wxCommandEvent& event)
{
     *edit_log << _T("Pressed Viz2D - This function is not yet implemented\n");
}

/*
 * butt_viz3dClick
 */
void NerekFrm::butt_viz3dClick(wxCommandEvent& event)
{
     *edit_log << _T("Pressed Viz3D - This function is not yet implemented\n");
}

/*
 * butt_createClick
 */
void NerekFrm::butt_createClick(wxCommandEvent& event)
{
	*edit_log << _T("Pressed Create\n");
    *edit_log << _T("Input Layers  = ") << edit_ilayers->GetValue() << _T("\n");
    *edit_log << _T("Output Layers = ") << edit_olayers->GetValue() << _T("\n");
    *edit_log << _T("Learning Rate = ") << edit_rate->GetValue() << _T("\n");
    *edit_log << _T("Bias          = ") << edit_bias->GetValue() << _T("\n");
	*edit_log << _T("Iterations    = ") << edit_iterations->GetValue() << _T("\n");
}

/*
 * toolbutt_newtrainClick
 */
void NerekFrm::toolbutt_newtrainClick(wxCommandEvent& event)
{
     *edit_log << _T("Pressed New Training Data\n");
     Dialog_Train *new_train = new Dialog_Train(this);
     //SetTopWindow(new_train);
     new_train->Show(TRUE);

}
