//---------------------------------------------------------------------------
//
// Name:        nerek_frm.h
// Author:      Chad Rempp
// Created:     6/7/2005 1:06:41 PM
//
//---------------------------------------------------------------------------
#ifndef __nerek_frm_HPP_
#define __nerek_frm_HPP_

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

//Do not add custom headers.
//wx-dvcpp designer will remove them
////Header Include Start
#include <wx/menu.h>
#include <wx/button.h>
#include <wx/textctrl.h>
#include <wx/stattext.h>
#include <wx/panel.h>
#include <wx/toolbar.h>
#include <wx/statusbr.h>
////Header Include End

#include <wx/frame.h>

////Dialog Style Start
	#define THIS_DIALOG_STYLE wxCAPTION | wxSYSTEM_MENU | wxDIALOG_NO_PARENT | wxMINIMIZE_BOX |  wxCLOSE_BOX
////Dialog Style End

class NerekFrm : public wxFrame
{
private:
    DECLARE_EVENT_TABLE()
public:
    NerekFrm( wxWindow *parent, wxWindowID id = 1, const wxString &title = _T("nerek"),
        const wxPoint& pos = wxDefaultPosition,
        const wxSize& size = wxDefaultSize,
        long style = THIS_DIALOG_STYLE);
    virtual ~NerekFrm();
public:
  //Do not add custom Control Declarations here.
  //wx-devcpp will remove them. Try adding the custom code 
  //after the block.
  ////GUI Control Declaration Start
	wxMenuBar *menu_controls;
	wxButton *butt_create;
	wxStaticText *stattext_log;
	wxTextCtrl *edit_log;
	wxButton *butt_viz3d;
	wxButton *butt_viz2d;
	wxButton *butt_test;
	wxButton *butt_train;
	wxTextCtrl *edit_iterations;
	wxTextCtrl *edit_bias;
	wxTextCtrl *edit_rate;
	wxTextCtrl *edit_olayers;
	wxTextCtrl *edit_ilayers;
	wxStaticText *stattext_bias;
	wxStaticText *stattext_rate;
	wxStaticText *stattext_iterations;
	wxStaticText *stattext_olayers;
	wxStaticText *stattext_ilayers;
	wxPanel *panel_controls;
	wxToolBar *toolbar_controls;
	wxStatusBar *statbar_controls;
  ////GUI Control Declaration End
public:
	//Note: if you receive any error with these enums, then you need to
    //change your old form code that are based on the #define control ids.
	//It may replace a numeric value in the enums names.
	enum {
////GUI Enum Control ID Start
ID_MNU_FILE_1003 = 1003 ,
ID_MNU_E_XIT_1005 = 1005 ,
ID_MNU__HELP_1004 = 1004 ,
ID_MNU__ABOUT_1006 = 1006 ,

ID_BUTT_CREATE = 1032 ,
ID_STATTEXT_LOG = 1031 ,
ID_EDIT_LOG = 1030 ,
ID_BUTT_VIZ3D = 1025 ,
ID_BUTT_VIZ2D = 1024 ,
ID_BUTT_TEST = 1022 ,
ID_BUTT_TRAIN = 1021 ,
ID_EDIT_ITERATIONS = 1020 ,
ID_EDIT_BIAS = 1019 ,
ID_EDIT_RATE = 1018 ,
ID_EDIT_OLAYERS = 1017 ,
ID_EDIT_ILAYERS = 1015 ,
ID_STATTEXT_BIAS = 1014 ,
ID_STATTEXT_RATE = 1013 ,
ID_STATTEXT_ITERATIONS = 1012 ,
ID_STATTEXT_OLAYERS = 1011 ,
ID_STATTEXT_ILAYERS = 1010 ,
ID_PANEL_CONTROLS = 1009 ,
ID_TOOLBUTT_OPENTRAIN = 1029 ,
ID_TOOLBUTT_OPENDATA = 1028 ,
ID_TOOLBUTT_OPENNET = 1027 ,
ID_TOOLBUTT_NEWTRAIN = 1026 ,
ID_TOOLBUTT_NEWDATA = 1023 ,
ID_TOOLBUTT_NEWNET = 1008 ,
ID_TOOLBAR_CONTROLS = 1007 ,
ID_STATBAR_CONTROLS = 1002 ,
////GUI Enum Control ID End
   ID_DUMMY_VALUE_ //Dont Delete this DummyValue
   }; //End of Enum
public:
    void NerekFrmClose(wxCloseEvent& event);
    void CreateGUIControls(void);
	void Mnuexit1005Click(wxCommandEvent& event);
	void Mnuabout1006Click(wxCommandEvent& event);
	void butt_trainClick(wxCommandEvent& event);
	void butt_testClick(wxCommandEvent& event);
	void butt_viz2dClick(wxCommandEvent& event);
	void butt_viz3dClick(wxCommandEvent& event);
	void butt_createClick(wxCommandEvent& event);
	void toolbutt_newtrainClick(wxCommandEvent& event);

};

#endif
 
 
 
 
